<?php

function shellfix($s){return "'".str_replace("'", "'\''", $s)."'";}

$error = '';

if(strlen($text) && isset($type) && !($scalef < 0))
{
  $enc = '';
  exec('/usr/local/bin/barcodehelper '.shellfix($text).' '.(int)($type), $lines);
  if(count($lines) >= 5)
  {
    $data = array();
    foreach($lines as $s)
      $data[$s[0]] = substr($s, 2);
    $enc = $data['E'];
  }
  
  if(!$font)$font = 'verdana';

  $pathinfo =  '/t'.((int)$type).
               '/e'.rawurlencode($enc).
               '/s'.rawurlencode($scalef);
  if($anno)
    $pathinfo .= '/f'.rawurlencode($font);
  $pathinfo .= '/a'.rawurlencode($anno).
               '/y'.rawurlencode($ysize).
               '/x'.rawurlencode(str_replace('/','',$text))
              .'.png';
  header('Location: http://bisqwit.iki.fi/barcode'.$pathinfo);
  return;
}

if($PATH_INFO)
{
  $params = explode('/', ereg_replace('\.png$', '', $PATH_INFO));
  $dotext = 1;
  $font  = 'verdana';
  $ysize = 80;
  $type  = 0;
  $nega  = 0;
  foreach($params as $s)
  {
    if($s[0]=='t')    $type   = substr($s, 1);
    elseif($s[0]=='e')$enc    = substr($s, 1);
    elseif($s[0]=='y')$ysize  = (int)substr($s, 1);
    elseif($s[0]=='n')$nega   = substr($s, 1);
    elseif($s[0]=='s')$scalef = substr($s, 1);
    elseif($s[0]=='a')$dotext = substr($s, 1);
    elseif($s[0]=='f')$font   = ereg_replace('[^a-z0-9]','', strtolower(substr($s, 1)));
    elseif($s[0]=='x')$text   = str_replace('','/',substr($s, 1));
  }
  if(!$text)
  {
    $text = '*CHIII*';
    $type = 4; //code39
  }
  if($ysize < 20)
    $ysize = 20;
  if($ysize > 200)
    $ysize = 200;
  
  include '/WWW/smallcache.php';
  $cache = new Cache($PATH_INFO, filemtime('barcode.php'));
  if($cache->Have())
  {
    header('Content-type: image/png');
    $cache->Dump();
    return;
  }
  
  $cmd = '/usr/local/bin/barcodehelper '.shellfix($text).' '.(int)($type);
  exec($cmd, $lines);
  if(count($lines) < 5)
  {
    $error = 'The selected setup ('.$cmd.') was not supported or valid.';
    $cache->_Cache();
    unset($cache);
  }
  else
  {
    $cache->Start();
    
    $data = array();
    foreach($lines as $s)
      $data[$s[0]] = substr($s, 2);
    
    $margin   = (int)$data['M'];
    $partial  = $data['P'];
    $textinfo = $data['T'];
    
    $scalef = 1.0 * $scalef;
    if($scalef < 0.2)
      $scalef = 1.0;
    elseif($scalef > 10.0)
      $scalef = 10.0;
    
    $bars = array();
    $chrs = array();

    $maxxpos = 0;
    $maxypos = $ysize*$scalef;

    $mode = '-';
    $xpos = $margin + (int)$partial[0] * $scalef;
    for($c=$i=1; $c<strlen($partial); $c++,$i++)
    {
      $ch = $partial[$c];
      if($ch == '+' || $ch == '-')
      {
        $mode = $ch; $i++; continue;
      }
      $j = ereg('[0-9]', $ch) ? ((int)$ch) : (1+ord($ch)-ord('a'));
      if($i % 2) // bar
      {
        $x0 = $xpos;
        $y0 = $margin;
        $height = $maxypos;
        if($dotext) // text?
        {
          if($mode == '-')
          {
            $y0     += (ereg('[0-9]', $ch) ? 10 : 5) * $scalef;
            $height -= (ereg('[0-9]', $ch) ? 10 : 5) * $scalef;
          }
          else
          {
            $y0     += (ereg('[0-9]', $ch) ? 10 : 5) * $scalef;
            $height -= (ereg('[0-9]', $ch) ? 30 : 5) * $scalef;
          }
        }
        $width = $scalef * $j - 0.15; // 0.15 = ink spread space
        
        // OUTPUT BAR: x0,y0,  width,height
        $bars[] = array('x0'=>$x0, 'y0'=>$y0, 'width'=>$width, 'height'=>$height);
      }
      $xpos += $scalef * $j;
      $maxxpos = $xpos;
    }
    
    $maxxpos += $scalef;
    
    $mode = '-';
    if($dotext)
    {
      $k=0; /* k is the "previous font size" */
      foreach(explode(' ', $textinfo) as $ptr)
      {
        while($ptr[0]=='-' || $ptr[0]=='+') { $mode = $ptr[0]; $ptr = substr($ptr, 1); }
        $c=' ';
        sscanf($ptr, '%lf:%lf:%c', $f1, $f2, $c);
        
        $x0 = $margin + $f1 * $scalef;
        if($mode == '-')
          $y0 = $margin;
        else
          $y0 = $margin + $maxypos - ($f2*1.5)*$scalef;
        $fontsize = $f2 * $scalef;
        
        // OUTPUT CHAR: x0,y0, fontsize, $c;
        $chrs[] = array('x0'=>$x0, 'y0'=>$y0, 'size'=>$fontsize, 'ch'=>$c);
      }
    }
    $im = ImageCreateTrueColor($maxxpos, $maxypos-8);
    $back = ImageColorAllocate($im, 250,255,255);
    $black = ImageColorAllocate($im, 0,0,0);
    if($nega) { $tmp=$back;$back=$black;$black=$tmp;unset($tmp); }
/*  for($c=1; $c<255;$c++)
      $tmp = ImageColorAllocate($im, $c,$c,$c);
*/  ImageFilledRectangle($im, 0,0,$maxxpos,$maxypos, $back);

    foreach($bars as $tab)
    {
      //print "OUTPUT BAR: pos=($tab[x0],$tab[y0]) size=($tab[width],$tab[height])\n";
      ImageFilledRectangle($im,
        (int)(0.5 + $tab[x0]),
        (int)(0.5 + $maxypos-($tab[y0]+$tab[height]-1)),
        ceil($tab[x0]+$tab[width]-1),
        ceil($maxypos-$tab[y0]),
        $black);
    }
    foreach($chrs as $tab)
    {
      $x0 = $tab[x0];
      $y0 = $tab[y0];
      $size = $tab[size];
      //$x0 -= $size/2;
      //$y0 -= $size/2;
      $y0 = $maxypos - $y0;
      
      //print "OUTPUT CHAR: pos=($tab[x0],$tab[y0]) size=$tab[size], char='$tab[ch]'\n";
      ImageTTFtext($im, $size*0.7, 0, $x0,$y0, $black,
                   '/WWW/'.$font.'.ttf',
                   $tab[ch]
                  );
    }
    header('Content-type: image/png');
    ImagePNG($im);
    ImageDestroy($im);
    
    $cache->_Cache();
    unset($cache);
    
    return;
  }
/*
Example:
A ikimashou
P 0 b1 a2 a4 142112241211142112413111121124114212122411134111124211221114 b3 c1 a1 b
T 11:12:i 22:12:k 33:12:i 44:12:m 55:12:a 66:12:s 77:12:h 88:12:o 99:12:u
E code 128-B
X 0
M 10
*/
}


header('Content-type: text/html; charset=iso-8859-1');

include '/WWW/possible304.php';
Check304(array('barcode.php'));

echo '<html><head><title>',
         htmlspecialchars('Online barcode generator'),
     '</title>',
     '</head>',
     '<body style="background:white;color:black">',
      '<h1>Online barcode generator</h1>';

print "\n";
if($error)
{
  echo '<p>', htmlspecialchars($error), '</p>';
  print "\n";
}

//$def = '6413600013105';       // pepsimax
//$def = '0-201-63371-x 53995'; // isbn of "More Effective C++"
$def = '332960073452'; // dark angel
?>
<form method=GET action="barcode">
 Code: <input type=text name=text maxlength=64 value="<?=$def?>"><br>
 Height: <input type=text name=ysize maxlength=5 size=2 value="80"> Scale factor: <input type=text maxlength=10 size=5 name=scalef value="2.0"><br>
 <input type=checkbox checked name=anno value=1> Annotated with <select name=font>
 <option value=arial>Arial</option>
 <option value=verdana>Verdana</option>
</select> font<br>
 Barcode type:
<?php

$lines=array();
exec("grep '^ *BARCODE_' /usr/include/barcode.h|sed 's/[= 0]*,//'", $lines);

print '<select name=type style="font-family:courier,monospace">';

foreach($lines as $c => $l)
{
  echo '<option value=', $c, '>';
  
  $s1 = str_replace('BARCODE_','',ereg_replace('/.*','',str_replace(' ', '', $l)));
  $s2 = ereg_replace('^ *[A-Z0-9_]* *', '', $l);
  
  $s2 = ereg_replace('/\* *', '(', $s2);
  $s2 = ereg_replace(' *\*/ *', ')', $s2);
  
  $s = sprintf('%8s %s', $s1, $s2);
  print str_replace(' ', '', htmlspecialchars($s));
  
  echo '</option>';
  echo "\n";
}
?>
  </select>
<br>

 <input type=submit value="Generate barcode">
</form>
<p>
<table width="100%" cellspacing=0 cellpadding=0>
<tr><td valign=top>
Written by <a href="http://bisqwit.iki.fi/">Bisqwit</a><br>
<a href="http://bisqwit.iki.fi/source/barcodetest.html">Utilizes</a>
    <a href="http://www.gnu.org/software/barcode/">GNU barcode</a>,
    <a href="http://www.php.net/ImageFilledRectangle">php, gd</a>
and <a href="http://www.freetype.org/">freetype</a>.<br>
</td>
<td width=20>&nbsp;</td>
<td valign=top style="text-align:justify;padding-right:6%">
This online service is free for personal or commercial use.<br>
You are not allowed to link directly to the generated pictures
(i.e. use them with <code>img src</code> on your webpages).
If you do, you'll gain bad reputation and ip bans etc.
</td>
</tr></table>
<p style="margin-left:6%;margin-right:6%">
No warranty. From the GNU barcode documentation:
<blockquote style="text-align:justify">
Please take the "no-warranty" disclaimer seriously: even though I
spent reasonable efforts to make sure the output is useable in
production you should verify it suits your needs as a faulty bar can
cost you a bundle, and you'll be on your own. It's up to you to verify
that the symbol is valid (and, obviously, I'd like to know about any
problem you encounter). [This paragraph copied verbatim from bookland.py]
</blockquote>
</p>
<p>
Tll on mys <a href="pankkiviiva">suomalainen pankkiviivakoodigeneraattori</a>
(here's a Finnish bank barcode generator).
</p>
<p>
<small>
<em>Note: All requests are logged with your IP address, time and the exact request.</em>
<br>&nbsp;<br>&nbsp;<br><small>
<a href="/source/barcodetest.html">Source</a></small>
</small>
</p>
 </body>
</html>
