<?php

/*
  Testilaskut:
    101710-122      4883.15       86851 62596 19897      16.6.2006
    457611-2124     482.99        55958 22432 94671      31.1.2000
    500046-41302    693.80     69 87567 20834 35364      22.6.2007
    660100-1530641  7444.54     7 75847 47906 47489      27.10.1998
    800014-50267    935.85     78 77767 96566 28687      0.0.0
    313130-1000058  3928.37                 8 68624      18.3.2004
    330100-01100775 1500.20 92125 37425 25398 97737      31.12.2002
    344994-827436   0                    5907 38390      27.12.1999
*/

if(!$tilinumero || !$viite)
{
  ?><html><head><title>Pankkiviivakooditykalu</title>
   </head><body>
  <h1>Pankki<a style="color:black" href="barcode">viivakooditykalu</a></h1>
  Huom., tm tykalu ei ole Suomen Pankkiyhdistyksell hyvksytetty.<br>
  Kyttminen kaupallisiin tarkoituksiin ei ole
  suositeltavaa, ja saattaa olla jopa laitonta.
  <p>
  <form method=GET action="pankkiviiva">
   Tilinumero: <input type=text name=tilinumero maxlength=15 size=16> (muotoa nnnnnn-nnnnnnnn)<br>
   Summa: <input type=text name=summa maxlength=10 size=10> &euro; (ei yli 999&nbsp;999,99)<br>
   Viite: <input type=text name=viite maxlength=30 size=24><br>
   Erpiv: <input type=text name=erapaiva size=10 maxlength=10> (pp.kk.vvvv)<br>
   <input type=submit value="Generoi viivakoodi">
  </form>
  <p>
<small>
<em>Huom: Palvelin tallettaa kaikki haut IP-osoitteen ja kellonajan kera.</em>
</small>
  </p>
<p>
<small>
Tietolhde:
<a href="http://www.pankkiyhdistys.fi/sisalto/upload/pdf/pviivakoodistd.pdf">Suomen Pankkiyhdistyksen pankkiviivakoodidokumentti</a><br>
Toteuttaja: <a href="/">Joel Yliluoma</a>
</small>
  </p>
  </body></html>
  <?return;
}

/*
$tilinumero = '101710-122';
$summa      = '4 883,15';
$viite      = '68851 62596 19897';
$erapaiva   = '060616';
*/

$erapaiva = ereg_replace('[ ]', '', str_replace(',', '.', $erapaiva));
sscanf($erapaiva, '%d.%d.%d', $d,$m,$y);
$erapaiva = sprintf('%02d%02d%02d', $y%100,$m,$d);

$summa = ereg_replace('[ ]', '', str_replace(',', '.', $summa));

$tilinumero = ereg_replace('[^0-9]','',$tilinumero);
$tilinumero = substr($tilinumero,0,6).str_pad(substr($tilinumero,6),8,'0',STR_PAD_LEFT);
$eurot  = str_pad((int)$summa,6,'0',STR_PAD_LEFT);
$sentit = str_pad((int)($summa*100)%100,2,'0',STR_PAD_LEFT);
$viite = ereg_replace('[^0-9]','',$viite);
$viite  = str_pad($viite,20,'0',STR_PAD_LEFT);

$viivakoodi =
  sprintf('2%14s%6s%2s%20s%6s0000',
      $tilinumero, // 14 numeroa, tytt nollilla 6. merkin jlkeen
      $eurot,      // 000000-999999
      $sentit,     // 00-99
      $viite,      // 20 numeroa, etunollatytt
      $erapaiva    // vvkkpp tai 000000
         );
$summa = 0;
$kaa=0;
$kerr=array(0=>7,1=>3,2=>1);
for($c=strlen($viivakoodi);--$c >= 0; $kaa++)
{
  $kerroin = $kerr[$kaa%3];
  $summa += $kerroin * (int)$viivakoodi[$c];
}
$viivakoodi .= chr(ord('0') + (10-$summa%10)%10);

header('Location: http://bisqwit.iki.fi/barcode?anno=0&ysize=80&scalef=1&type=6&text='.rawurlencode($viivakoodi));
